<p-table #dt [scrollable]="true" [value]="organizationUnits" selectionMode="single" [(selection)]="selectedOrganizationUnit"
    (onRowSelect)="sendToCategories($event.data)" (onRowUnselect)="sendToCategories(null)"
    [globalFilterFields]="['name']" styleClass="p-datatable-striped" tableStyleClass="table-with-action-buttons">
    <ng-template pTemplate="caption">
        <div style="text-align:center">Organization units</div>
        <!-- <input type="text" pInputText size="50" placeholder="Search"
            (input)="dt.filterGlobal($event.target.value, 'contains')" style="width:100%"> -->
    </ng-template>
    <ng-template pTemplate="header">
        <tr>
            <th class="rowStyle">Name</th>
            <th *ngIf="hasWritePermission" style="width: 37px;">
                <button pButton icon="fa fa-plus" (click)="onAddOrganizationUnit()"></button>
            </th>
        </tr>
    </ng-template>
    <ng-template pTemplate="body" let-organizationUnit>
        <tr [pSelectableRow]="organizationUnit">
            <td>{{organizationUnit.name}}</td>
            <td *ngIf="hasWritePermission">
                <div class="d-flex justify-content-between">
                    <button pButton icon="fa fa-pencil" (click)="onEditOrganizationUnit(organizationUnit)"></button>
                </div>
            </td>
        </tr>
    </ng-template>
</p-table>

<p-dialog header="Organization unit" [(visible)]="dialogVisible" [responsive]="true" [resizable]="false"
    showEffect="fade" [modal]="true" [style]="{ 'width': '530px' }">
    <form [formGroup]="unitForm" (ngSubmit)="onSaveOrganizationUnit()">
    <div class="form-group form-row" style="margin-top: 1rem">
        <div class="col-md-2 col-form-label text-md-right">
            Name
        </div>
        <div class="col-md-10">
            <input formControlName="unitName" id="unitName" pInputText [(ngModel)]="editOrganizationUnit.name" type="text" class="w-100" />
            <div *ngIf="f['unitName'].touched && f['unitName'].invalid" class="text-danger">
                <div *ngIf="f['unitName'].errors && f['unitName'].errors['required']">Name is required.</div>
                <div *ngIf="f['unitName'].errors && f['unitName'].errors['maxlength']">Name must be less than 100 characters long</div>
                <div *ngIf="f['unitName'].errors && f['unitName'].errors['canNotContainWhiteSpaces']">Name can not contain whitespaces</div>
            </div>
        </div>
    </div>

    <div class="form-group form-row">
        <div class="col-md-2 col-form-label text-md-right">
            Division
        </div>
        <div class="col-md-10">
            <p-dropdown [(ngModel)]="editOrganizationUnit.division" [options]="divisions" [style]="{ 'width': '100%' }" appendTo="body" [ngModelOptions]="{standalone: true}">
            </p-dropdown>
        </div>
    </div>

    <div class="form-group form-row">
        <div class="col-12 text-right">
            <button pButton label="Save" [disabled]="unitForm.invalid" type="submit"></button>
        </div>
    </div>
</form>
</p-dialog>